# Developer Guide

This guide is intended to provide developers with instructions as to how to
contribute to declearn, what the coding and documentation style rules are,
and which tools may or should be used to lint and test your code.

This guide is structured this way:

- [Contributions guide](./contribute.md):<br/>
    Guide on our use of git and gitlab, and overview of our coding rules.
- [Unit tests and code analysis](./tests.md):<br/>
    Information on how to run the tests and lint your code.
- [Building the documentation](./docs-build.md):<br/>
    Guide on how to build and render the package's documentation.
- [Docstrings style guide](./docs-style.md):<br/>
    Guide on how to format docstrings and have them properly rendered.
