# declearn v2.2.2

Released: 06/09/2023

This is a subminor release that patches a regression introduced in v2.2.0 but
was undetected before.

## Hotfix: fix DP-SGD with TorchModel

Since version 2.2.0, the functorch-based backend for computing and clipping
sample-wise gradients of a `TorchModel` has attempted to benefit from the
experimental `functorch.compile` API. However, this change, which has been
tested to yield performance gains on fixed-size batches of inputs, turns out
not to be compatible with variable-size batches - which are mandatory as part
of DP-SGD due to the use of Poisson sampling.

As a consequence, this version drops the use of `functorch.compile`, restoring
DP-SGD features with `TorchModel``.
